﻿local GarrisonDone_Update_ToGo = 0
local GarrisonDone_Update_Frequency = 30
local GarrisonDoneReport_Update_ToGo = 0
local GarrisonDoneReport_Update_Frequency = 1

local GarrisonDone_StartTime = 0


local tempSortedList = {}

local sortOrders = {
		{name = "Player", value = "player"}
	}

  self:RegisterEvent("GARRISON_MISSION_FINISHED")
  self:RegisterEvent("GARRISON_MISSION_LIST_UPDATE")
  self:RegisterEvent("GARRISON_MISSION_COMPLETE_RESPONSE")


function GarrisonDone_OnEvent(self, event, ...)
	if (event=="VARIABLES_LOADED") then
		if not GarrisonDone_Vars[GetUnitName("player")] then
			GarrisonDone_Vars[GetUnitName("player")] = {}
		end
		if not GarrisonDone_VarsChar then
			GarrisonDone_VarsChar = {}
		end
	elseif (event=="GARRISON_MISSION_FINISHED") then
		GarrisonDone_Update()
	elseif (event == "GARRISON_MISSION_COMPLETE_RESPONSE") then
		GarrisonDone_Cleanup()
	elseif (event == "GARRISON_MISSION_LIST_UPDATE") then
		GarrisonDone_Update()
    end   
end

function GarrisonDone_Display()
	if GarrisonDone_Vars then
			for player, v2 in pairs(v1) do
				for missionId, data in pairs(v2) do
                    local color = ""
					end
					if data.endTime < time() then
						print(player.."- : |cffff0000completed")
					else
						print(player.."- : "..date("%m/%d/%y %H:%M",data.endTime))
			end
		end
	end
end

function GarrisonDone_Rebuild()
	local template = "GarrisonDone_"..GetRealmName().."_"..GetUnitName("player").."_"
	for index, object in pairs(barList) do
		if string.find("GarrisonDone_"..GetRealmName().."_"..GetUnitName("player").."_", index) then
			unUsedBars[#unUsedBars + 1] = object
			object.bar:Hide()
			barList[index] = nil
		end
	end
	GarrisonDone_Vars[GetRealmName()][GetUnitName("player")] = {}
	GarrisonDone_Update()
end

function GarrisonDone_Cleanup()
	local missionsLeft = {}
	local updatePending = false
	local mt = C_Garrison.GetInProgressMissions()
	--/run for key,value in pairs(C_Garrison.GetInProgressMissions()[1]) do print(key, value) end
	for index, v in ipairs(mt) do
		missionsLeft[#missionsLeft + 1] = v.missionID
	end
	if GarrisonDone_Vars[GetRealmName()][GetUnitName("player")] then
		for j = #GarrisonDone_Vars[GetRealmName()][GetUnitName("player")], 1, -1 do
			local value = GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][j]
			local exists = false
			for i = 1,#missionsLeft,1 do
				if missionsLeft[i] == value.missionID then
					exists = true
				end
			end
			if not exists then
                -- Not bars, a List
				tremove(GarrisonDone_Vars[GetRealmName()][GetUnitName("player")], j)
				if barList["GarrisonDone_"..GetRealmName().."_"..GetUnitName("player").."_"..value.missionID] then
					unUsedBars[#unUsedBars + 1] = barList["GarrisonDone_"..GetRealmName().."_"..GetUnitName("player").."_"..value.missionID]
					barList["GarrisonDone_"..GetRealmName().."_"..GetUnitName("player").."_"..value.missionID].bar:Hide()
					barList["GarrisonDone_"..GetRealmName().."_"..GetUnitName("player").."_"..value.missionID] = nil
					updatePending = true
				end
			end
		end
	end
	if updatePending then
		local i = 0
		if GarrisonDone_Vars then
			for id, object in pairs(barList) do
				object.bar:ClearAllPoints()
				object.bar:SetPoint("TOPLEFT", "GarrisonDoneReport", 30, -60-15*i)
				i = i + 1
			end
		end
	end
end

function GarrisonDone_Update(data)
	local mt = C_Garrison.GetInProgressMissions()
	--/run for key,value in pairs(C_Garrison.GetInProgressMissions()[1]) do print(key, value) end
	for index, v in ipairs(mt) do
		if(type(v) == "table") then
			local newIndex = #GarrisonDone_Vars[GetUnitName("player")] + 1
			local endTime = time()
			local num = select('#',strsplit(" ",v.timeLeft))
			local detailedTime = false
			for i = 1, num, 2 do
				local var = select(i,strsplit(" ",v.timeLeft))
				local unit = select(i+1,strsplit(" ",v.timeLeft))
				if(unit == "days") then
					endTime = endTime + var*24*3600
				elseif(unit == "hr") then
					endTime = endTime + var*3600
				elseif(unit == "min") then
					endTime = endTime + var*60
				elseif(unit == "sec") then
					endTime = endTime + var
					detailedTime = true
				end
			end
			if(data and data.missionID and data.missionID == v.missionID) then
				data.timeLeft = v.timeLeft
				data.endTime = endTime
				data.detailedTime = true
			elseif (not data) then
				if( not GarrisonDone_Vars) then
					GarrisonDone_Vars = {}
				end
				if (not GarrisonDone_Vars[GetRealmName()]) then
					GarrisonDone_Vars[GetRealmName()] = {}
				end
				if( not GarrisonDone_Vars[GetRealmName()][GetUnitName("player")]) then
					GarrisonDone_Vars[GetRealmName()][GetUnitName("player")] = {}
				end
				newIndex = GarrisonDone_InTable(GarrisonDone_Vars[GetRealmName()][GetUnitName("player")], v.missionID, newIndex)
				if( not GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex] ) then
					GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex] = {}
				end
				
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].durationSeconds = v.durationSeconds
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].timeLeft = v.timeLeft
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].missionID = v.missionID
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].endTime = endTime
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].player = GetUnitName("player")
				if not GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].displayed then
					GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].displayed = false
				end
				if not GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].detailedTime then
					GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].detailedTime = detailedTime
				end
			end
		end
	end
end

function GarrisonDone_InTable(tab, missionID, oldIndex)
	for i = 1, #tab, 1 do
		if(tab[i].missionID == missionID) then
			return i
		end
	end
	return oldIndex
end



function GarrisonDone_OnUpdate(self, elapsed)
	GarrisonDone_Update_ToGo = GarrisonDone_Update_ToGo - elapsed;
	if GarrisonDone_Update_ToGo <= 0 then
		if GarrisonDone_Vars then
			for realm, v1 in pairs(GarrisonDone_Vars) do
				for player, v2 in pairs(v1) do
					for missionId, data in pairs(v2) do
						if ((data.endTime < time()) and (data.displayed == false)) then
							if not data.detailedTime then
								--GarrisonDone_Update(data.missionID)
							else
								data.displayed = true
								local color = "|cffffffff"
								print(player.."- : |cffff0000completed")
							end
						end
					end
				end
			end
		end
		GarrisonDone_Update_ToGo = GarrisonDone_Update_Frequency
	end
end





function GarrisonDone_SortList(sortOrder)
if (sortOrder == "player") then
		for realm, v1 in pairs(GarrisonDone_Vars) do
			for player, v2 in pairs(v1) do
				for missionId, data in pairs(v2) do
					tempSortedList[#tempSortedList+1] = data
				end
			end
		end
		table.sort(tempSortedList,
			function(x,y)
				return x.player < y.player
			end
		)
	end
end

function GarrisonDoneReport_OnUpdate(self, elapsed)
	if not UnitAffectingCombat("player") then
		GarrisonDoneReport_Update_ToGo = GarrisonDoneReport_Update_ToGo - elapsed
		if GarrisonDoneReport_Update_ToGo <= 0 then
			local i = 0
			local b = 0
			if (#tempSortedList > 0) then
				for index, data in pairs(tempSortedList) do
					i = i + 1
					local offset = FauxScrollFrame_GetOffset(GarrisonDoneReportScrollFrame)
					if i > offset and i <= (offset + maxBars) then
						b = b + 1
						local name = data.name
						if data.player == nil then
							data.player = "Please reload "
						end
						if data.realm == nil then
							data.realm = "all players"
						end
						local t = data.endTime - time()
						local bar, texture, label, timeLabel, object
						local missionID = data.missionID
						bar = _G["GarrisonDone_bar_"..b]
						bar:SetMinMaxValues(0, data.durationSeconds)
						--bar:SetPoint("TOPLEFT", "GarrisonDoneReportScrollFrame", 25, 15-15*b)
						texture = _G["GarrisonDone_tex_"..b]
						texture:SetGradientAlpha("HORIZONTAL", 0.7, 0, 0, 0.5, 0.7, 0, 0, 0.7)
						timeLabel = _G["GarrisonDone_label_"..b]
						local minV, maxV = bar:GetMinMaxValues()
						if t > maxV then
							bar:SetMinMaxValues(0, data.durationSeconds)
						end
						local color = "|cffffffff"
						if t > 60 then
							bar:SetValue(floor(t))
							timeLabel:SetText(string.format("%02d:%02d:%02d %s", floor(t/3600), floor(mod(t,3600)/60), floor(mod(t, 60)), color..data.player.."-"..data.realm..":"..name))
						else
							if data.detailedTime == false and data.player == GetUnitName("player") then
								GarrisonDone_Update(data)
							end
							bar:SetValue(data.durationSeconds-1)
							--bar:SetStatusBarColor(0,0,1)
							texture:SetGradientAlpha("HORIZONTAL", 0, 0.7, 0, 0.5, 0, 0.7, 0, 1)
							timeLabel:SetText(string.format("%s: Done", color..data.player.."-"..data.realm..":"..name.."|cffffffff"))
						end
						bar:Show()
					end
				end
			else
				if GarrisonDone_Vars then
					for realm, v1 in pairs(GarrisonDone_Vars) do
						for player, v2 in pairs(v1) do
							for index, data in pairs(v2) do
								i = i + 1
								local offset = FauxScrollFrame_GetOffset(GarrisonDoneReportScrollFrame)
								if i > offset and i <= (offset + maxBars) then
									b = b + 1
									local name = data.name
									local t = data.endTime - time()
									local bar, texture, label, timeLabel, object
									local missionID = data.missionID
									bar = _G["GarrisonDone_bar_"..b]
									bar:SetMinMaxValues(0, data.durationSeconds)
									--bar:SetPoint("TOPLEFT", "GarrisonDoneReportScrollFrame", 25, 15-15*b)
									texture = _G["GarrisonDone_tex_"..b]
									texture:SetGradientAlpha("HORIZONTAL", 0.7, 0, 0, 0.5, 0.7, 0, 0, 0.7)
									timeLabel = _G["GarrisonDone_label_"..b]
									local minV, maxV = bar:GetMinMaxValues()
									if t > maxV then
										bar:SetMinMaxValues(0, data.durationSeconds)
									end
									local color = "|cffffffff"
									if data.isRare == true then
										color = "|cff0000ff"
									end
									if t > 60 then
										bar:SetValue(floor(t))
										timeLabel:SetText(string.format("%02d:%02d:%02d %s", floor(t/3600), floor(mod(t,3600)/60), floor(mod(t, 60)),":"..name))
									else
										if data.detailedTime == false and realm == GetRealmName() and player == GetUnitName("player") then
											GarrisonDone_Update(data)
										end
										bar:SetValue(data.durationSeconds-1)
										--bar:SetStatusBarColor(0,0,1)
										texture:SetGradientAlpha("HORIZONTAL", 0, 0.7, 0, 0.5, 0, 0.7, 0, 1)
										timeLabel:SetText(string.format("%s: Done", ":"..name.."|cffffffff"))
									end
									bar:Show()
								end
							end
						end
					end
				end
			end
			FauxScrollFrame_Update(GarrisonDoneReportScrollFrame, i, maxBars, 15)
			if b <= maxBars then
				b = b + 1
				for j = b,maxBars do
					_G["GarrisonDone_bar_"..j]:Hide()
				end
			end
			GarrisonDoneReport_Update_ToGo = GarrisonDoneReport_Update_Frequency
		end
		GarrisonDoneReportScrollFrame:Show()
	else
		GarrisonDoneReport:Hide()
	end
end

